"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const bn_js_1 = __importDefault(require("bn.js"));
class PerpEventQueue {
    constructor(decoded) {
        Object.assign(this, decoded);
    }
    getUnconsumedEvents() {
        const events = [];
        const head = this.head.toNumber();
        for (let i = 0; i < this.count.toNumber(); i++) {
            events.push(this.events[(head + i) % this.events.length]);
        }
        return events;
    }
    // add getConsumedEventsSince()
    // calls eventsSince and removes the last n elements from the array based on this.count
    eventsSince(lastSeqNum) {
        // TODO doesn't work when lastSeqNum == 0; please fix
        const modulo64Uint = new bn_js_1.default('10000000000000000', 'hex');
        let missedEvents = this.seqNum
            .add(modulo64Uint)
            .sub(lastSeqNum)
            .mod(modulo64Uint);
        /*
        console.log({
          last: lastSeqNum.toString(),
          now: this.seqNum.toString(),
          missed: missedEvents.toString(),
          mod: modulo64Uint.toString(),
        });
        */
        const bufferLength = new bn_js_1.default(this.events.length);
        if (missedEvents.gte(bufferLength)) {
            missedEvents = bufferLength.sub(new bn_js_1.default(1));
        }
        const endIndex = this.head.add(this.count).mod(bufferLength);
        const startIndex = endIndex
            .add(bufferLength)
            .sub(missedEvents)
            .mod(bufferLength);
        /*
        console.log({
          bufLength: bufferLength.toString(),
          missed: missedEvents.toString(),
          head: this.head.toString(),
          count: this.count.toString(),
          end: endIndex.toString(),
          start: startIndex.toString(),
        });
        */
        const results = [];
        let index = startIndex;
        while (!index.eq(endIndex)) {
            const event = this.events[index.toNumber()];
            if (event.fill || event.out || event.liquidate)
                results.push(event);
            index = index.add(new bn_js_1.default(1)).mod(bufferLength);
        }
        return results;
    }
}
exports.default = PerpEventQueue;
//# sourceMappingURL=PerpEventQueue.js.map