"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
This will probably move to its own repo at some point but easier to keep it here for now
 */
const os = __importStar(require("os"));
const fs = __importStar(require("fs"));
const client_1 = require("./client");
const web3_js_1 = require("@solana/web3.js");
const utils_1 = require("./utils");
const ids_json_1 = __importDefault(require("./ids.json"));
const config_1 = require("./config");
const fixednum_1 = require("./fixednum");
const serum_1 = require("@project-serum/serum");
const bn_js_1 = __importDefault(require("bn.js"));
const layout_1 = require("./layout");
const _1 = require(".");
const interval = parseInt(process.env.INTERVAL || '3500');
const refreshAccountsInterval = parseInt(process.env.INTERVAL || '30000');
const config = new config_1.Config(ids_json_1.default);
const cluster = (process.env.CLUSTER || 'devnet');
const groupName = process.env.GROUP || 'devnet.1';
const groupIds = config.getGroup(cluster, groupName);
if (!groupIds) {
    throw new Error(`Group ${groupName} not found`);
}
const openOrdersAccountSpan = serum_1.OpenOrders.getLayout(groupIds.serumProgramId).span;
const openOrdersAccountOwnerOffset = serum_1.OpenOrders.getLayout(groupIds.serumProgramId).offsetOf('owner');
const mangoProgramId = groupIds.mangoProgramId;
const mangoGroupKey = groupIds.publicKey;
const payer = new web3_js_1.Account(JSON.parse(process.env.KEYPAIR ||
    fs.readFileSync(os.homedir() + '/.config/solana/devnet.json', 'utf-8')));
console.log(`Payer: ${payer.publicKey.toBase58()}`);
const connection = new web3_js_1.Connection(config.cluster_urls[cluster], 'processed');
const client = new client_1.MangoClient(connection, mangoProgramId);
const liqorMangoAccountKey = new web3_js_1.PublicKey('Db6shuaGQC9rJjfK9wYRXVTAdSWCiDbEYDgyVidfWMqH');
const liqeeMangoAccountKey = new web3_js_1.PublicKey('CiLbJRhSj4cqYYwn3Sxs5PvYnshrowDR4XELBmAiWQPn');
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        if (!groupIds) {
            throw new Error(`Group ${groupName} not found`);
        }
        const m = yield serum_1.Market.load(connection, new web3_js_1.PublicKey('4DhsFeFJKHU53G2JkPeAx6tLPsStETDyhxbCdoWMM6FS'), undefined, groupIds.serumProgramId);
        console.log(m['_decoded'].quoteLotSize.toString(), m['_decoded'].baseLotSize.toString());
        if (m) {
            return;
        }
        console.log(`Starting liquidator for ${groupName}...`);
        const liquidating = {};
        const mangoGroup = yield client.getMangoGroup(mangoGroupKey);
        let mangoAccounts = [];
        yield refreshAccounts(mangoAccounts, mangoGroup);
        watchAccounts(mangoAccounts, mangoGroup);
        // eslint-disable-next-line
        while (true) {
            try {
                console.time('groupInfo');
                const mangoGroup = yield client.getMangoGroup(mangoGroupKey);
                const cache = yield mangoGroup.loadCache(connection);
                const liqorMangoAccount = yield client.getMangoAccount(liqorMangoAccountKey, mangoGroup.dexProgramId);
                yield utils_1.sleep(interval);
                const perpMarkets = yield Promise.all(groupIds.perpMarkets.map((perpMarket, index) => {
                    return mangoGroup.loadPerpMarket(connection, index, perpMarket.baseDecimals, perpMarket.quoteDecimals);
                }));
                const spotMarkets = yield Promise.all(groupIds.spotMarkets.map((spotMarket) => {
                    return serum_1.Market.load(connection, spotMarket.publicKey, undefined, groupIds.serumProgramId);
                }));
                const rootBanks = yield mangoGroup.loadRootBanks(connection);
                console.timeEnd('groupInfo');
                yield utils_1.sleep(interval);
                console.time('checkAccounts');
                for (let mangoAccount of mangoAccounts) {
                    try {
                        const health = mangoAccount.getHealth(mangoGroup, cache, 'Maint');
                        if (health.lt(fixednum_1.ZERO_I80F48)) {
                            if (!liquidating[mangoAccount.publicKey.toBase58()] &&
                                mangoAccount.publicKey.equals(liqeeMangoAccountKey)) {
                                console.log(`Sick account ${mangoAccount.publicKey.toBase58()} health: ${health.toString()}`);
                                liquidating[mangoAccount.publicKey.toBase58()] = true;
                                // TODO: Check bankruptcy here
                                console.log('forceCancelPerpOrders');
                                // TODO: Only do this for markets with oos
                                yield Promise.all(perpMarkets.map((perpMarket) => {
                                    return client.forceCancelPerpOrders(mangoGroup, mangoAccount, perpMarket, payer, new bn_js_1.default(5));
                                }));
                                yield utils_1.sleep(interval * 5);
                                mangoAccount = yield mangoAccount.reload(connection);
                                yield Promise.all([
                                    liquidateSpot(mangoGroup, cache, spotMarkets, rootBanks, mangoAccount, liqorMangoAccount),
                                    liquidatePerps(mangoGroup, cache, perpMarkets, rootBanks, mangoAccount, liqorMangoAccount),
                                ])
                                    .then((values) => {
                                    console.log('Liquidated account', mangoAccount.publicKey.toBase58());
                                    console.log(values);
                                })
                                    .catch((err) => {
                                    console.log('Failed to liquidate account', mangoAccount.publicKey.toBase58(), err);
                                })
                                    .finally(() => {
                                    liquidating[mangoAccount.publicKey.toBase58()] = false;
                                });
                            }
                        }
                    }
                    catch (err) {
                        console.error(`Failed to process account ${mangoAccount.publicKey.toBase58()}`, err);
                    }
                }
                console.timeEnd('checkAccounts');
                yield utils_1.sleep(interval);
            }
            catch (err) { }
        }
    });
}
function watchAccounts(mangoAccounts, mangoGroup) {
    connection.onProgramAccountChange(mangoGroup.publicKey, ({ accountId, accountInfo }) => {
        if (accountInfo.data.length == layout_1.MangoAccountLayout.span) {
            const mangoAccount = new _1.MangoAccount(accountId, layout_1.MangoAccountLayout.decode(accountInfo.data));
            const index = mangoAccounts.findIndex((account) => account.publicKey.equals(mangoAccount.publicKey));
            mangoAccounts[index] = mangoAccount;
        }
    }, 'singleGossip', [{ dataSize: layout_1.MangoAccountLayout.span }]);
    connection.onProgramAccountChange(mangoGroup.dexProgramId, ({ accountId, accountInfo }) => {
        if (accountInfo.data.length == openOrdersAccountSpan) {
            console.log('oos changed');
            console.log(accountId.toBase58());
            const ownerIndex = mangoAccounts.findIndex((account) => account.spotOpenOrders.some((key) => key.equals(accountId)));
            if (ownerIndex > -1) {
                console.log('found owner');
                mangoAccounts[ownerIndex].spotOpenOrdersAccounts.forEach((oo, i) => {
                    if (oo && oo.address.equals(accountId)) {
                        console.log('updated account at ' + i);
                        mangoAccounts[ownerIndex].spotOpenOrdersAccounts[i] =
                            serum_1.OpenOrders.fromAccountInfo(accountId, accountInfo, mangoGroup.dexProgramId);
                    }
                });
            }
            else {
                console.error('Could not match OpenOrdersAccount to MangoAccount');
            }
        }
    }, 'singleGossip', [
        {
            memcmp: {
                offset: openOrdersAccountOwnerOffset,
                bytes: mangoGroup.signerKey.toBase58(),
            },
        },
    ]);
}
function refreshAccounts(mangoAccounts, mangoGroup) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            console.log('Refreshing accounts...');
            console.time('getAllMangoAccounts');
            const accounts = yield client.getAllMangoAccounts(mangoGroup, undefined, true);
            mangoAccounts.splice(0, mangoAccounts.length, ...accounts);
            console.timeEnd('getAllMangoAccounts');
            console.log(`Fetched ${accounts.length} accounts`);
        }
        catch (err) {
            console.error('Error reloading accounts', err);
        }
        finally {
            setTimeout(refreshAccounts, refreshAccountsInterval, mangoAccounts, mangoGroup);
        }
    });
}
function liquidateSpot(mangoGroup, cache, spotMarkets, rootBanks, liqee, liqor) {
    return __awaiter(this, void 0, void 0, function* () {
        console.log('liquidateSpot');
        for (let i = 0; i < mangoGroup.spotMarkets.length - 1; i++) {
            const spotMarket = spotMarkets[i];
            const spotMarketInfo = mangoGroup.spotMarkets[i];
            const baseRootBank = rootBanks[i];
            const quoteRootBank = rootBanks[rootBanks.length - 1];
            if (baseRootBank && quoteRootBank) {
                if (liqee.inMarginBasket[i]) {
                    console.log('cancelling spot for market ', i);
                    yield client.forceCancelSpotOrders(mangoGroup, liqee, spotMarket, baseRootBank, quoteRootBank, payer, new bn_js_1.default(1));
                    yield utils_1.sleep(interval);
                }
            }
        }
        let minNet = fixednum_1.ZERO_I80F48;
        let minNetIndex = -1;
        let maxNet = fixednum_1.ZERO_I80F48;
        let maxNetIndex = layout_1.QUOTE_INDEX;
        if (minNetIndex === -1) {
            // In this case, send a random token account that is not maxNetIndex
            minNetIndex = (maxNetIndex + 1) % mangoGroup.tokens.length;
        }
        for (let i = 0; i < mangoGroup.tokens.length; i++) {
            const price = cache.priceCache[i] ? cache.priceCache[i].price : fixednum_1.ONE_I80F48;
            const netDeposit = liqee
                .getNativeDeposit(cache.rootBankCache[i], i)
                .sub(liqee.getNativeBorrow(cache.rootBankCache[i], i))
                .mul(price);
            if (netDeposit.lt(minNet)) {
                minNet = netDeposit;
                minNetIndex = i;
            }
            else if (netDeposit.gt(maxNet)) {
                maxNet = netDeposit;
                maxNetIndex = i;
            }
        }
        if (minNetIndex == -1) {
            throw new Error('min net index neg 1');
        }
        console.log(minNetIndex);
        console.log(minNet.toString());
        console.log(maxNetIndex);
        console.log(maxNet.toString());
        console.log(liqee
            .getNativeBorrow(cache.rootBankCache[minNetIndex], minNetIndex)
            .toString());
        const liabRootBank = rootBanks[minNetIndex];
        const assetRootBank = rootBanks[maxNetIndex];
        if (assetRootBank && liabRootBank) {
            yield client.liquidateTokenAndToken(mangoGroup, liqee, liqor, assetRootBank, liabRootBank, payer, new fixednum_1.I80F48(utils_1.uiToNative(1000, mangoGroup.tokens[minNetIndex].decimals)));
            console.log('liquidated max ' +
                utils_1.uiToNative(1000, mangoGroup.tokens[minNetIndex].decimals).toString() +
                ' of liab');
            liqee = yield liqee.reload(connection);
            if (liqee.isBankrupt) {
                console.log('Bankrupt account', liqee.publicKey.toBase58());
                const quoteRootBank = rootBanks[layout_1.QUOTE_INDEX];
                if (quoteRootBank) {
                    yield client.resolveTokenBankruptcy(mangoGroup, liqee, liqor, quoteRootBank, liabRootBank, payer, new fixednum_1.I80F48(utils_1.uiToNative(10000000, mangoGroup.tokens[minNetIndex].decimals)));
                }
            }
        }
    });
}
function liquidatePerps(mangoGroup, cache, perpMarkets, rootBanks, liqee, liqor) {
    return __awaiter(this, void 0, void 0, function* () {
        console.log('liquidatePerps');
        const lowestHealthMarket = mangoGroup.perpMarkets
            .map((perpMarketInfo, marketIndex) => {
            const perpAccount = liqee.perpAccounts[marketIndex];
            const perpMarketCache = cache.perpMarketCache[marketIndex];
            const price = mangoGroup.getPrice(marketIndex, cache);
            const perpHealth = perpAccount.getHealth(perpMarketInfo, price, perpMarketInfo.maintAssetWeight, perpMarketInfo.maintLiabWeight, perpMarketCache.longFunding, perpMarketCache.shortFunding);
            return { perpHealth: perpHealth, marketIndex: marketIndex };
        })
            .sort((a, b) => {
            return a.perpHealth.sub(b.perpHealth).toNumber();
        })[0];
        const marketIndex = lowestHealthMarket.marketIndex;
        const perpAccount = liqee.perpAccounts[marketIndex];
        const perpMarket = perpMarkets[marketIndex];
        const baseRootBank = rootBanks[marketIndex];
        if (!baseRootBank) {
            throw new Error(`Base root bank not found for ${marketIndex}`);
        }
        if (lowestHealthMarket.perpHealth.lt(fixednum_1.ZERO_I80F48)) {
            let maxNet = fixednum_1.ZERO_I80F48;
            let maxNetIndex = mangoGroup.tokens.length - 1;
            for (let i = 0; i < mangoGroup.tokens.length; i++) {
                const price = cache.priceCache[i]
                    ? cache.priceCache[i].price
                    : fixednum_1.ONE_I80F48;
                const netDeposit = liqee
                    .getNativeDeposit(cache.rootBankCache[i], i)
                    .sub(liqee.getNativeBorrow(cache.rootBankCache[i], i))
                    .mul(price);
                if (netDeposit.gt(maxNet)) {
                    maxNet = netDeposit;
                    maxNetIndex = i;
                }
            }
            const assetRootBank = rootBanks[maxNetIndex];
            if (perpAccount.basePosition.eq(new bn_js_1.default(0))) {
                if (assetRootBank) {
                    console.log('liquidateTokenAndPerp ' + marketIndex);
                    yield client.liquidateTokenAndPerp(mangoGroup, liqee, liqor, assetRootBank, payer, 0 /* Token */, maxNetIndex, 1 /* Perp */, marketIndex, new fixednum_1.I80F48(utils_1.uiToNative(1000, mangoGroup.tokens[marketIndex].decimals)));
                }
            }
            else {
                console.log('liquidatePerpMarket ' + marketIndex);
                yield client.liquidatePerpMarket(mangoGroup, liqee, liqor, perpMarkets[marketIndex], payer, utils_1.uiToNative(1000, mangoGroup.tokens[marketIndex].decimals));
            }
            yield utils_1.sleep(interval);
            liqee = yield liqee.reload(connection);
            if (liqee.isBankrupt) {
                console.log('Bankrupt account', liqee.publicKey.toBase58());
                yield client.resolvePerpBankruptcy(mangoGroup, liqee, liqor, perpMarket, baseRootBank, payer, marketIndex, new fixednum_1.I80F48(utils_1.uiToNative(100, mangoGroup.tokens[marketIndex].decimals)));
            }
        }
    });
}
main();
//# sourceMappingURL=liquidator.js.map